#!/usr/bin/perl 
#
#BUGS:

#AUTHOR:
#Irina Zorkoltseva 


#CREATED:
#22.11.2004 14:30

#LAST MODIFIED:
#17.09.2005 9:00

#LANGUAGE:
#Perl v5.8.4

#OS: 
#XXX Linux vXX.XX

# pre_pedcheck.pl: recodes initial pedigree and genotype data files 
#		  to ped+data file and list markers file for pedcheck
#		rewrite pedcheck error file



#******** default parametrs ************************

$name="pre_pedcheck.pl";
$inped="pedigree.dat"; # input pedigree data file
$indat="genotype.dat";     # input genotype data file
$oped="pedfile.dat";       # output pedigree and genotype data file
$list="marker.dat";        # output list of analyzed markers
$err="pre_pedcheck.err";
$pedtmp="temp.dat";      # temp pedigree data (with old id)

$sep=";";    # input separator
$out="\t";   # output separator
$x=0;	# x=1 if X-cromosoma, x=0 if autosoma
$mis=" ";
# get command line arguments 
#**************** check the comand line ************
unless (@ARGV) {
	&PRN_PAR;
}


#*************** reparametrization *************************
else {
	$narg = @ARGV;
	for ($i=0;$i<$narg-1;$i++) 
	{
		$sep=$ARGV[$i+1] if ($ARGV[$i] =~ /-s/);
		$indat=$ARGV[$i+1] if ($ARGV[$i] =~ /-d/);
		$inped=$ARGV[$i+1] if ($ARGV[$i] =~ /-p/);
		$x=1 if ($ARGV[i] =~ /-x/);

	}
	&PRN_PAR;
}
open(ERR,">$err"); 

 & PED_READ;    ## reading and checking pedigree file
 & PED; 	## count the size of each family
 & GEN_READ;    ## reading and checking genotype file

print (ERR "$error_m\n");
die " Fatal errors exist. See error file for details.\n" if ($error_m);

##**************** link genotype data to ID *************

open(TMP,">$pedtmp") or die "ERROR: cannot open temp pedigree file $pedtmp: $!\n"; 
print (TMP "ped;id;fa;mo;sex;code;old_id\n");

open(OUT,">$oped") or die "ERROR: cannot open out pedigree file $oped: $!\n";
print "\nLinking genotype data to ID and writing output file...\n"; 


for ($i=0; $i<$nids; $i++) {
$j=$ped[$i]-1;

if ($size[$j] gt 1) {
print (TMP "$ped[$i]$sep$id[$i]$sep$fa[$i]$sep$mo[$i]$sep$sex[$i]$sep$cod[$i]$sep$old[$i]\n");


unless ($cod[$i]) {print (OUT "$ped[$i]$out$id[$i]$out$fa[$i]$out$mo[$i]$out$sex[$i]$out${tr_0}\n") }
if ($cod[$i]) {
$luk=0;
for ($ii=0; $ii<$nnids; $ii++) {
    next if ($cod[$i] ne $rsp[$ii]);
print (OUT  "$ped[$i]$out$id[$i]$out$fa[$i]$out$mo[$i]$out$sex[$i]$out${tr[$ii]}\n");
$luk=1;
}
unless ($luk) {
print (OUT "$ped[$i]$out$id[$i]$out$fa[$i]$out$mo[$i]$out$sex[$i]$out${tr_0}\n");
print "WARNING: Per. $id[$i]($cod[$i]) has no genotype data\n";
print (ERR "WARNING: Per. $id[$i]($cod[$i]) has no genotype data\n");
                }
     }
}
}


sub PRN_PAR {
print "\n$name input patameters

\tInput pedigree file: -p=\"$inped\"
\tInput genotype file: -d=\"$indat\"
\tField input_separator: -s=\"$sep\"\n";

}

sub PED {
$j=0;
	for ($i=0;$i<$nids;$i++)  {
		$size[$j] = $size[$j] + 1;                                                              
		  if ($ped[$i+1] ne $ped[$i]) {
		  $j++;	
			}
		}
$nped=$j;

}

sub CRTINS {
$k=0;
$ins[0]=$ins[2]=1;
$ins[1]=0;
for ($k=0;$k<=nids;$k++) {
if ($ped[k+1] ne $ped[k]) {
	$ins[0]++;
	$l = $ins[0];
	$ins[$l+2] = $ins[$l+1]++;
 	}
if ($ped[k+1] eq $ped[k]) {
   $l = $ins[0];
	$ins[$l+2]++;
}	
}
}



sub PED_READ {
#************open and read the pedigree data******************
                                   
open(INP,"$inped") or die "ERROR: cannot open pedigree file $inped: $!\n"; 
#*********check the header line ********************
$hea="# ";
$line=0;
while ($hea =~ /^#/) {
	$line++;
	$hea = <INP>;
}
chomp $hea;

@header = split(/$sep/, $hea, -1 );

$enid=$enped=$enfa=$enmo=$ensex=$encod=$enold=0;

#**************count the number of required entries

for ($i=0;$i<@header;$i++) {
	$enid++ if ($header[$i] =~ /^id$/);
	$enped++ if ($header[$i] =~ /^ped$/);
	$enfa++ if ($header[$i] =~ /^fa$/);
	$enmo++ if ($header[$i] =~ /^mo$/);
	$ensex++ if ($header[$i] =~ /^sex$/);
	$encod++ if ($header[$i] =~ /^code$/);
	$enold++ if ($header[$i] =~ /^old_id$/);
}

$error_m = "${error_m}FATAL ERROR: Pedigree (ped) column not found in input file\n" if ($enped==0);
$error_m = "${error_m}FATAL ERROR: Personal ID (id) column not found in input file\n" if ($enid==0);
$error_m = "${error_m}FATAL ERROR: Father ID (fa) column not found in input file\n" if ($enfa==0);
$error_m = "${error_m}FATAL ERROR: Mother ID (mo) column not found in input file\n" if ($enmo==0);
$error_m = "${error_m}FATAL ERROR: Sex (sex) column not found in input file\n" if ($ensex==0);
$error_m = "${error_m}FATAL ERROR: Code (code) column not found in input file\n" if ($encod==0);

$error_m = "${error_m}FATAL ERROR: Personal ID (id) column found more then once in input file\n" if ($enid>1);
$error_m = "${error_m}FATAL ERROR: Pedigree (ped) column found more then once in input file\n" if ($enped>1);
$error_m = "${error_m}FATAL ERROR: Father ID (fa) column found more then once in input file\n" if ($enfa>1);
$error_m = "${error_m}FATAL ERROR: Mother ID (mo) column found more then once in input file\n" if ($enmo>1);
$error_m = "${error_m}FATAL ERROR: Sex (sex) column found more then once in input file\n" if ($ensex>1);
$error_m = "${error_m}FATAL ERROR: Code (code) column found more then once in input file\n" if ($encod>1);
$error_m = "${error_m}FATAL ERROR: Personal Old ID (old_id) column found more then once in input file\n" if ($enold>1);

$no_err=0;
if ($enid==0 or $enfa==0 or $enmo==0 or $ensex==0 or $encod==0 or $enped>1 or $enid>1 or $enfa>1 or $enmo>1 or $ensex>1 or $encod>1 or $enold>1) {$no_err=1};
if ($no_err) {
	close INP;
	print (ERR "$error_m");
die " Fatal errors exist. See error file for details.\n";
}


#find the position of required entries

for ($i=0;$i<@header;$i++) {
	$enid=$i+1 if ($header[$i] =~ /^id$/);
	$enped=$i+1 if ($header[$i] =~ /^ped$/);
	$enfa=$i+1 if ($header[$i] =~ /^fa$/);
	$enmo=$i+1 if ($header[$i] =~ /^mo$/);
	$ensex=$i+1 if ($header[$i] =~ /^sex$/);
	$encod=$i+1 if ($header[$i] =~ /^code$/);
	$enold=$i+1 if ($header[$i] =~ /^old_id$/);
}

###################reading the pedigree ...
#print "Reading pedigree data...\n";

$noent = @header;
$nids=0;
$no_err=0;
$i=0;
while (<INP>) {
	next if (/^#/);
	next if (/^ *$/);
	chomp;
#	$_="$_${sep}1";
	@temp = split/$sep/;
	$tmp=@temp-1;
	

	$ped[$i]=$temp[$enped-1];
	$id[$i]=$temp[$enid-1];
	$fa[$i]=$temp[$enfa-1];
	$mo[$i]=$temp[$enmo-1];
	$sex[$i]=$temp[$ensex-1];
	$cod[$i]=$temp[$encod-1];                                     
	$old[$i]=$temp[$enold-1] if ($enold !=0); 	
if ($enold == 0) {$old[$i]="$ped[$i]_$id[$i]";}



#	print "i=$i$sep$id[$i]$sep $cod[$i]$sep $old[$i]$sep\n";	
	$i++;
	splice @temp,0,$tmp;
}
$nids=$i;
die "ERROR: empty pedigree file\n" if ($i<1);




close INP;  # end read pedigree file
# print "End reading pedigree file: nids eq $nids\n";

}

sub GEN_READ {
#************open and read the genotype data******************
         
open(INP,"$indat") or die "ERROR: cannot open file with genotype data $indat: $!\n"; 

#*********check the header line ********************

$hea="# ";
while ($hea =~ /^#/) {
	$line++;
	$hea = <INP>;
}
chomp $hea;                                       
@header = split(/$sep/, $hea, -1 );
#print @header;
$encod=0;
$no_err=0;

#**************count the number of required entries
                                                
for ($i=0;$i<@header;$i++) {
	$encod++ if ($header[$i] =~ /^code$/);

}
 if ($encod==0) {
$no_err=1;
$error_m = "${error_m}ERROR: Code (code) column not found in input file\n";
print (ERR "\$error_m\n");
die "$error_m\n";
}
   
#header of marker names

$head_trait="";
$n_tr=0;
$h_tr=1;

for ($i=0;$i<@header;$i++)
 {	
next if $i eq $encod-1;
#$head_trait="${head_trait}$header[$i]${out}";
	$head_trait[$n_tr]=$header[$i];
	$n_tr++; 
}
$error_m = "${error_m}ERROR: Marker's column not found in input file\n" if ($n_tr==0);
$no_err=1 unless ($n_tr);
#print "number of columns=$n_tr\n";

#*** Creating list markers file **********

open(ML,">$list"); 

for ($i=0;$i<$n_tr-1;$i+=2)
 {	
	if ($head_trait[$i+1] ne $head_trait[$i]) {
	$h_tr=0 ;
#	print "No two columns for marker $head_trait[$i]\n";
}

#print "$head_trait[$i]\n";
print (ML "$head_trait[$i]\n");
}
$error_m = "${error_m}ERROR: No quite enough marker's columns\n" unless ($h_tr);

$no_err=1 unless ($h_tr);
if ($no_err) {
	close INP;
	die "FATAL ERROR: see error file for details\n";
};



###################read in the genotype file ...

print "Reading genotype data...\n";

$noent = @header;
$nnids=0;
$no_err=0;
$i=0;

while (<INP>) {
	next if (/^#/);
	next if (/^ *$/);
	chomp;

	$_="$_${sep}1";
	@temp = split/$sep/;
	$rsp[$i]=$temp[$encod-1];
	$tmp=@temp-1;
#print "$tmp\n" if($rsp[$i]==36069528);
$error_m = "${error_m}FATAL ERROR: No quite enough marker's data on per.$rsp[$i]\n" if ($tmp<$n_tr);

#	$tr[$i]="";
	for ($j=0;$j<$tmp;$j++)
 {
                                              
		next if ($j == $encod-1);
		

if ($temp[$j] ne " ") {
#print  " 111 tr $tr[$i] temp: \"$temp[$j]\" \n" if($rsp[$i]==36069528);

$tr[$i]="${tr[$i]}$temp[$j]${out}";}
else   {$tr[$i]="${tr[$i]}0${out}";
#print  "222 $tr[$i] $temp[$j] \n" if($rsp[$i]==36069528);
    }

}                                                              
#print  "$rsp[$i] $tr[$i] \n" if($rsp[$i]==36069528);
 	$i++;
	splice @temp,0,$tmp;
}
$nnids=$i;
die "ERROR: empty genotype data file\n" if ($nnids<1);

######################## check duplicated code...

for ($i=0; $i<$nnids; $i++) {
             $cid=$rsp[$i];
	for ($j=$i+1; $j<$nids; $j++) {
	$error_m="${error_m}ERROR: Personal code $cid duplicated in lines $i and $j\n" if ($cid eq $rsp[$j]);
}

}

#$tr_0="";
	for ($j=0;$j<$tmp-1;$j++)
 {
		$tr_0="${tr_0}0${out}";
}
#print " tr0= $tr_0 tmp2= $tmp\n";

close INP;
print "End reading genotype file";

}
