#!/usr/bin/perl 
#

$name="rec_check_err.pl";
$version="0.0.1";

$sep=";";
$inp="pedigree.int.csv";



#************open and read the list of markers******************


open(INM,"marker.dat");
$n=0;
while (<INM>) {
	next if (/^#/);
	next if (/^ *$/);
	chomp;
	$_="$_";
	$list{$n}=$_;
#print( "marker $list{$n}\n");
	$n++;
}
#############

#************open and read the pedigree data******************

#*************** reparametrization *************************
if (@ARGV)  {
	$narg = @ARGV;
	for ($i=0;$i<$narg-1;$i++) 
	{
		$sep=$ARGV[$i+1] if ($ARGV[$i] =~ /-s/);
		$inp=$ARGV[$i+1] if ($ARGV[$i] =~ /-p/);

	}
}

open(INP,$inp);


#*********check the header line ********************
$hea="# ";
$line=0;
while ($hea =~ /^#/) {
	$line++;
	$hea = <INP>;
}
chomp $hea;

@header = split(/$sep/, $hea, -1 );


#find the position of required entries

for ($i=0;$i<@header;$i++) {
	$enid=$i if ($header[$i] =~ /^id$/);
	$enped=$i if ($header[$i] =~ /^ped$/);
	$enfa=$i if ($header[$i] =~ /^fa$/);
	$enmo=$i if ($header[$i] =~ /^mo$/);
	$ensex=$i if ($header[$i] =~ /^sex$/);
	$encod=$i if ($header[$i] =~ /^code$/);
	$enold=$i if ($header[$i] =~ /^old_id$/);
}



###################read in the pedigree ...

#print "Reading pedigree data...\n";

$noent = @header;
$nids=0;
$no_err=0;
$i=0;
while (<INP>) {
	next if (/^#/);
##	next if (/^ *$/);
	chomp;
	$_="$_${sep}1";
	@temp = split/$sep/;
	$tmp=@temp-1;
	


	$id[$i]=$temp[1];
	$cod[$i]=$temp[5];
	$old[$i]=$temp[6];

#	print "i=$i$sep$id[$i]$sep $cod[$i]$sep $old[$i]$sep\n";	
	$i++;
	splice @temp,0,$tmp;
}
$nids=$i;
#print "nid= $i\n";
die "Empty pedigree file\n" if ($i<1);
$no_err++ if ($nids<1);

close INP;

#************open and read the error file******************


open(ERR,"pedcheck.err");
open(OUT,">pedcheck_rec.err");

#print "Reading error file...\n";

$se=" ";
while (<ERR>) {
	chop;
	@temp=split;
	$tmp=@temp-1; # Number of entres in reading line
	
for ($i=0;$i<@temp;$i++) {
	
    if ($temp[$i] =~/^Father$/ or $temp[$i]=~/^Mother$/ or $temp[$i]=~ /^Child$/ or $temp[$i]=~ /^Per:$/ or $temp[$i]=~ /^Person$/) {
	$nm=$temp[$i+1];
#	print (OUT "$temp[$i+1]$sep");
	$nom=--$nm+1;
	if ($nom>0) {
 &RECODE;              

#	print "$temp[$i]=$nom";
#	print (OUT "$temp[$i] $temp[$i+1] $nom\n");
	                                 $temp[$i+1]=$nom;
}
}

#************** finding marker's name in error file

   if ($temp[$i] =~/^Locus$/) {
	$m=$temp[$i+1];
	$n_mark[$m]++;
}

}
if($temp[0] ne "If" and $temp[0] ne "PedCheck:" and $temp[0] ne "Incompatibilities" and $temp[0] ne "O'Connell") {           print(OUT "@temp\n");}
if($temp[$tmp] =~/^marker.dat$/) {
print (OUT "Analyzed markers:\n");
for ($k=1;$k<=$n;$k++) {
print (OUT "            Locus $k Name $list{$k-1}\n");}
}
if($temp[$tmp] =~/^-------------------------------------------------$/ and $luk==0) {

print (OUT "\! Errors not found:\n");
for ($k=1;$k<=$n;$k++) {
print (OUT "\! Marker $list{$k-1}\n") if ($n_mark[$k]==0);}
print (OUT "\!\n");
$luk++;
}

}
close ERR;
print"\ END OF PROGRAM\n";
sub RECODE {
$ierr=1;

for (my $i=0;$i<$nids;$i++){
if($id[$i]==$nom) {
	$nom="$old[$i] ($cod[$i])";
	$ierr=0;
}
}
die "Number $nom not found\n" if ($ierr!=0);
}
